Index: /palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3003)
+++ /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3004)
@@ -886,183 +934,207 @@
 !--          In case of land- and urban-surfaces, convert fluxes into
 !--          dynamic units.
-             DO  m = 1, surf_def_h(0)%ns
-                i = surf_def_h(0)%i(m)
-                j = surf_def_h(0)%j(m)
-                k = surf_def_h(0)%k(m)
-                shf_av(j,i) = shf_av(j,i) + surf_def_h(0)%shf(m)  *            &
-                                            heatflux_output_conversion(k)
-             ENDDO
-             DO  m = 1, surf_lsm_h%ns
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-                shf_av(j,i) = shf_av(j,i) + surf_lsm_h%shf(m) * cp
-             ENDDO
-             DO  m = 1, surf_usm_h%ns
-                i = surf_usm_h%i(m)
-                j = surf_usm_h%j(m)
-                shf_av(j,i) = shf_av(j,i) + surf_usm_h%shf(m) * cp
-             ENDDO
+             IF ( ALLOCATED( shf_av ) ) THEN 
+                DO  m = 1, surf_def_h(0)%ns
+                   i = surf_def_h(0)%i(m)
+                   j = surf_def_h(0)%j(m)
+                   k = surf_def_h(0)%k(m)
+                   shf_av(j,i) = shf_av(j,i) + surf_def_h(0)%shf(m)  *            &
+                                               heatflux_output_conversion(k)
+                ENDDO
+                DO  m = 1, surf_lsm_h%ns
+                   i = surf_lsm_h%i(m)
+                   j = surf_lsm_h%j(m)
+                   shf_av(j,i) = shf_av(j,i) + surf_lsm_h%shf(m) * cp
+                ENDDO
+                DO  m = 1, surf_usm_h%ns
+                   i = surf_usm_h%i(m)
+                   j = surf_usm_h%j(m)
+                   shf_av(j,i) = shf_av(j,i) + surf_usm_h%shf(m) * cp
+                ENDDO
+             ENDIF
 
           CASE ( 'ssws*' )
-             DO  m = 1, surf_def_h(0)%ns
-                i = surf_def_h(0)%i(m)
-                j = surf_def_h(0)%j(m)
-                ssws_av(j,i) = ssws_av(j,i) + surf_def_h(0)%ssws(m)
-             ENDDO
-             DO  m = 1, surf_lsm_h%ns
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-                ssws_av(j,i) = ssws_av(j,i) + surf_lsm_h%ssws(m)
-             ENDDO
-             DO  m = 1, surf_usm_h%ns
-                i = surf_usm_h%i(m)
-                j = surf_usm_h%j(m)
-                ssws_av(j,i) = ssws_av(j,i) + surf_usm_h%ssws(m)
-             ENDDO
+             IF ( ALLOCATED( ssws_av ) ) THEN 
+                DO  m = 1, surf_def_h(0)%ns
+                   i = surf_def_h(0)%i(m)
+                   j = surf_def_h(0)%j(m)
+                   ssws_av(j,i) = ssws_av(j,i) + surf_def_h(0)%ssws(m)
+                ENDDO
+                DO  m = 1, surf_lsm_h%ns
+                   i = surf_lsm_h%i(m)
+                   j = surf_lsm_h%j(m)
+                   ssws_av(j,i) = ssws_av(j,i) + surf_lsm_h%ssws(m)
+                ENDDO
+                DO  m = 1, surf_usm_h%ns
+                   i = surf_usm_h%i(m)
+                   j = surf_usm_h%j(m)
+                   ssws_av(j,i) = ssws_av(j,i) + surf_usm_h%ssws(m)
+                ENDDO
+             ENDIF
 
           CASE ( 't*' )
-             DO  m = 1, surf_def_h(0)%ns
-                i = surf_def_h(0)%i(m)
-                j = surf_def_h(0)%j(m)
-                ts_av(j,i) = ts_av(j,i) + surf_def_h(0)%ts(m)
-             ENDDO
-             DO  m = 1, surf_lsm_h%ns
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-                ts_av(j,i) = ts_av(j,i) + surf_lsm_h%ts(m)
-             ENDDO
-             DO  m = 1, surf_usm_h%ns
-                i = surf_usm_h%i(m)
-                j = surf_usm_h%j(m)
-                ts_av(j,i) = ts_av(j,i) + surf_usm_h%ts(m)
-             ENDDO
+             IF ( ALLOCATED( ts_av ) ) THEN 
+                DO  m = 1, surf_def_h(0)%ns
+                   i = surf_def_h(0)%i(m)
+                   j = surf_def_h(0)%j(m)
+                   ts_av(j,i) = ts_av(j,i) + surf_def_h(0)%ts(m)
+                ENDDO
+                DO  m = 1, surf_lsm_h%ns
+                   i = surf_lsm_h%i(m)
+                   j = surf_lsm_h%j(m)
+                   ts_av(j,i) = ts_av(j,i) + surf_lsm_h%ts(m)
+                ENDDO
+                DO  m = 1, surf_usm_h%ns
+                   i = surf_usm_h%i(m)
+                   j = surf_usm_h%j(m)
+                   ts_av(j,i) = ts_av(j,i) + surf_usm_h%ts(m)
+                ENDDO
+             ENDIF
 
           CASE ( 'tsurf*' )
-             DO  m = 1, surf_def_h(0)%ns
-                i   = surf_def_h(0)%i(m)            
-                j   = surf_def_h(0)%j(m)
-                tsurf_av(j,i) = tsurf_av(j,i) + surf_def_h(0)%pt_surface(m)
-             ENDDO
-
-             DO  m = 1, surf_lsm_h%ns
-                i   = surf_lsm_h%i(m)            
-                j   = surf_lsm_h%j(m)
-                tsurf_av(j,i) = tsurf_av(j,i) + surf_lsm_h%pt_surface(m)
-             ENDDO
-
-             DO  m = 1, surf_usm_h%ns
-                i   = surf_usm_h%i(m)            
-                j   = surf_usm_h%j(m)
-                tsurf_av(j,i) = tsurf_av(j,i) + surf_usm_h%pt_surface(m)
-             ENDDO
+             IF ( ALLOCATED( tsurf_av ) ) THEN             
+                DO  m = 1, surf_def_h(0)%ns
+                   i   = surf_def_h(0)%i(m)            
+                   j   = surf_def_h(0)%j(m)
+                   tsurf_av(j,i) = tsurf_av(j,i) + surf_def_h(0)%pt_surface(m)
+                ENDDO
+
+                DO  m = 1, surf_lsm_h%ns
+                   i   = surf_lsm_h%i(m)            
+                   j   = surf_lsm_h%j(m)
+                   tsurf_av(j,i) = tsurf_av(j,i) + surf_lsm_h%pt_surface(m)
+                ENDDO
+
+                DO  m = 1, surf_usm_h%ns
+                   i   = surf_usm_h%i(m)            
+                   j   = surf_usm_h%j(m)
+                   tsurf_av(j,i) = tsurf_av(j,i) + surf_usm_h%pt_surface(m)
+                ENDDO
+             ENDIF
 
           CASE ( 'u' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      u_av(k,j,i) = u_av(k,j,i) + u(k,j,i)
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( u_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         u_av(k,j,i) = u_av(k,j,i) + u(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'u*' )
-             DO  m = 1, surf_def_h(0)%ns
-                i = surf_def_h(0)%i(m)
-                j = surf_def_h(0)%j(m)
-                us_av(j,i) = us_av(j,i) + surf_def_h(0)%us(m)
-             ENDDO
-             DO  m = 1, surf_lsm_h%ns
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-                us_av(j,i) = us_av(j,i) + surf_lsm_h%us(m)
-             ENDDO
-             DO  m = 1, surf_usm_h%ns
-                i = surf_usm_h%i(m)
-                j = surf_usm_h%j(m)
-                us_av(j,i) = us_av(j,i) + surf_usm_h%us(m)
-             ENDDO
+             IF ( ALLOCATED( us_av ) ) THEN   
+                DO  m = 1, surf_def_h(0)%ns
+                   i = surf_def_h(0)%i(m)
+                   j = surf_def_h(0)%j(m)
+                   us_av(j,i) = us_av(j,i) + surf_def_h(0)%us(m)
+                ENDDO
+                DO  m = 1, surf_lsm_h%ns
+                   i = surf_lsm_h%i(m)
+                   j = surf_lsm_h%j(m)
+                   us_av(j,i) = us_av(j,i) + surf_lsm_h%us(m)
+                ENDDO
+                DO  m = 1, surf_usm_h%ns
+                   i = surf_usm_h%i(m)
+                   j = surf_usm_h%j(m)
+                   us_av(j,i) = us_av(j,i) + surf_usm_h%us(m)
+                ENDDO
+             ENDIF
 
           CASE ( 'v' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      v_av(k,j,i) = v_av(k,j,i) + v(k,j,i)
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( v_av ) ) THEN 
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         v_av(k,j,i) = v_av(k,j,i) + v(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'vpt' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      vpt_av(k,j,i) = vpt_av(k,j,i) + vpt(k,j,i)
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( vpt_av ) ) THEN 
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         vpt_av(k,j,i) = vpt_av(k,j,i) + vpt(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'w' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      w_av(k,j,i) = w_av(k,j,i) + w(k,j,i)
-                   ENDDO
-                ENDDO
-             ENDDO
+             IF ( ALLOCATED( w_av ) ) THEN 
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         w_av(k,j,i) = w_av(k,j,i) + w(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
 
           CASE ( 'z0*' )
-             DO  m = 1, surf_def_h(0)%ns
-                i = surf_def_h(0)%i(m)
-                j = surf_def_h(0)%j(m)
-                z0_av(j,i) = z0_av(j,i) + surf_def_h(0)%z0(m)
-             ENDDO
-             DO  m = 1, surf_lsm_h%ns
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-                z0_av(j,i) = z0_av(j,i) + surf_lsm_h%z0(m)
-             ENDDO
-             DO  m = 1, surf_usm_h%ns
-                i = surf_usm_h%i(m)
-                j = surf_usm_h%j(m)
-                z0_av(j,i) = z0_av(j,i) + surf_usm_h%z0(m)
-             ENDDO
+             IF ( ALLOCATED( z0_av ) ) THEN 
+                DO  m = 1, surf_def_h(0)%ns
+                   i = surf_def_h(0)%i(m)
+                   j = surf_def_h(0)%j(m)
+                   z0_av(j,i) = z0_av(j,i) + surf_def_h(0)%z0(m)
+                ENDDO
+                DO  m = 1, surf_lsm_h%ns
+                   i = surf_lsm_h%i(m)
+                   j = surf_lsm_h%j(m)
+                   z0_av(j,i) = z0_av(j,i) + surf_lsm_h%z0(m)
+                ENDDO
+                DO  m = 1, surf_usm_h%ns
+                   i = surf_usm_h%i(m)
+                   j = surf_usm_h%j(m)
+                   z0_av(j,i) = z0_av(j,i) + surf_usm_h%z0(m)
+                ENDDO
+             ENDIF
 
           CASE ( 'z0h*' )
-             DO  m = 1, surf_def_h(0)%ns
-                i = surf_def_h(0)%i(m)
-                j = surf_def_h(0)%j(m)
-                z0h_av(j,i) = z0h_av(j,i) + surf_def_h(0)%z0h(m)
-             ENDDO
-             DO  m = 1, surf_lsm_h%ns
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-                z0h_av(j,i) = z0h_av(j,i) + surf_lsm_h%z0h(m)
-             ENDDO
-             DO  m = 1, surf_usm_h%ns
-                i = surf_usm_h%i(m)
-                j = surf_usm_h%j(m)
-                z0h_av(j,i) = z0h_av(j,i) + surf_usm_h%z0h(m)
-             ENDDO
-
+             IF ( ALLOCATED( z0h_av ) ) THEN 
+                DO  m = 1, surf_def_h(0)%ns
+                   i = surf_def_h(0)%i(m)
+                   j = surf_def_h(0)%j(m)
+                   z0h_av(j,i) = z0h_av(j,i) + surf_def_h(0)%z0h(m)
+                ENDDO
+                DO  m = 1, surf_lsm_h%ns
+                   i = surf_lsm_h%i(m)
+                   j = surf_lsm_h%j(m)
+                   z0h_av(j,i) = z0h_av(j,i) + surf_lsm_h%z0h(m)
+                ENDDO
+                DO  m = 1, surf_usm_h%ns
+                   i = surf_usm_h%i(m)
+                   j = surf_usm_h%j(m)
+                   z0h_av(j,i) = z0h_av(j,i) + surf_usm_h%z0h(m)
+                ENDDO
+             ENDIF
+   
           CASE ( 'z0q*' )
-             DO  m = 1, surf_def_h(0)%ns
-                i = surf_def_h(0)%i(m)
-                j = surf_def_h(0)%j(m)
-                z0q_av(j,i) = z0q_av(j,i) + surf_def_h(0)%z0q(m)
-             ENDDO
-             DO  m = 1, surf_lsm_h%ns
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-                z0q_av(j,i) = z0q_av(j,i) + surf_lsm_h%z0q(m)
-             ENDDO
-             DO  m = 1, surf_usm_h%ns
-                i = surf_usm_h%i(m)
-                j = surf_usm_h%j(m)
-                z0q_av(j,i) = z0q_av(j,i) + surf_usm_h%z0q(m)
-             ENDDO
+             IF ( ALLOCATED( z0q_av ) ) THEN 
+                DO  m = 1, surf_def_h(0)%ns
+                   i = surf_def_h(0)%i(m)
+                   j = surf_def_h(0)%j(m)
+                   z0q_av(j,i) = z0q_av(j,i) + surf_def_h(0)%z0q(m)
+                ENDDO
+                DO  m = 1, surf_lsm_h%ns
+                   i = surf_lsm_h%i(m)
+                   j = surf_lsm_h%j(m)
+                   z0q_av(j,i) = z0q_av(j,i) + surf_lsm_h%z0q(m)
+                ENDDO
+                DO  m = 1, surf_usm_h%ns
+                   i = surf_usm_h%i(m)
+                   j = surf_usm_h%j(m)
+                   z0q_av(j,i) = z0q_av(j,i) + surf_usm_h%z0q(m)
+                ENDDO
+             ENDIF
 !             
 !--       Block of urban surface model outputs. 
 !--       In case of urban surface variables it should be always checked
 !--       if respective arrays are allocated, at least in case of a restart 
-!--       run, as usm arrays are not read from file at the moment. 
+!--       run, as averaged usm arrays are not read from file at the moment. 
           CASE ( 'usm_output' )
              CALL usm_average_3d_data( 'allocate', doav(ii) )
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 3003)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 3004)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! First call of flow_statistics has been removed. It is already called in 
+! run_control itself
+! 
+! 2984 2018-04-18 11:51:30Z hellstea
 ! CALL pmci_ensure_nest_mass_conservation is removed (so far only commented out)
 ! as seemingly unnecessary.
@@ -507,6 +511,6 @@
 !-- Determine and print out the run control quantities before the first time
 !-- step of this run. For the initial run, some statistics (e.g. divergence)
-!-- need to be determined first.
-    IF ( simulated_time == 0.0_wp )  CALL flow_statistics
+!-- need to be determined first --> CALL flow_statistics at the beginning of
+!-- run_control
     CALL run_control
 !
Index: /palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 3003)
+++ /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 3004)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Further allocation checks implemented
+! 
+! 2938 2018-03-27 15:52:42Z suehring
 ! Further todo's
 ! 
@@ -510,29 +513,35 @@
 
           CASE ( 'diss' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      diss_av(k,j,i) = diss_av(k,j,i) + diss(k,j,i)
+             IF ( ALLOCATED( diss_av ) ) THEN             
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         diss_av(k,j,i) = diss_av(k,j,i) + diss(k,j,i)
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
+             ENDIF
 
           CASE ( 'kh' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      kh_av(k,j,i) = kh_av(k,j,i) + kh(k,j,i)
+             IF ( ALLOCATED( kh_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         kh_av(k,j,i) = kh_av(k,j,i) + kh(k,j,i)
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
+             ENDIF
 
           CASE ( 'km' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      km_av(k,j,i) = km_av(k,j,i) + km(k,j,i)
+             IF ( ALLOCATED( km_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         km_av(k,j,i) = km_av(k,j,i) + km(k,j,i)
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
+             ENDIF
 
           CASE DEFAULT
@@ -546,32 +555,38 @@
 
           CASE ( 'diss' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      diss_av(k,j,i) = diss_av(k,j,i)                          & 
-                                     / REAL( average_count_3d, KIND=wp )
+             IF ( ALLOCATED( diss_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         diss_av(k,j,i) = diss_av(k,j,i)                       & 
+                                        / REAL( average_count_3d, KIND=wp )
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
+             ENDIF
 
           CASE ( 'kh' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      kh_av(k,j,i) = kh_av(k,j,i)                              & 
-                                     / REAL( average_count_3d, KIND=wp )
+             IF ( ALLOCATED( kh_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         kh_av(k,j,i) = kh_av(k,j,i)                           & 
+                                        / REAL( average_count_3d, KIND=wp )
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
+             ENDIF
 
           CASE ( 'km' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      km_av(k,j,i) = km_av(k,j,i)                              & 
-                                     / REAL( average_count_3d, KIND=wp )
+             IF ( ALLOCATED( km_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         km_av(k,j,i) = km_av(k,j,i)                           & 
+                                        / REAL( average_count_3d, KIND=wp )
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
+             ENDIF
 
        END SELECT
@@ -608,4 +623,6 @@
     LOGICAL ::  found   !< 
     LOGICAL ::  two_d   !< flag parameter that indicates 2D variables (horizontal cross sections)
+
+    REAL(wp) ::  fill_value = -999.0_wp  !< value for the _FillValue attribute
 
     REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb:nzt+1) ::  local_pf !< local
@@ -627,4 +644,8 @@
              ENDDO
           ELSE
+             IF ( .NOT. ALLOCATED( diss_av ) ) THEN
+                ALLOCATE( diss_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                diss_av = REAL( fill_value, KIND = wp )
+             ENDIF
              DO  i = nxl, nxr
                 DO  j = nys, nyn
@@ -648,4 +669,8 @@
              ENDDO
           ELSE
+             IF ( .NOT. ALLOCATED( diss_av ) ) THEN
+                ALLOCATE( diss_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                diss_av = REAL( fill_value, KIND = wp )
+             ENDIF
              DO  i = nxl, nxr
                 DO  j = nys, nyn
@@ -669,4 +694,8 @@
              ENDDO
           ELSE
+             IF ( .NOT. ALLOCATED( diss_av ) ) THEN
+                ALLOCATE( diss_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                diss_av = REAL( fill_value, KIND = wp )
+             ENDIF
              DO  i = nxl, nxr
                 DO  j = nys, nyn
@@ -710,4 +739,6 @@
 
     LOGICAL ::  found   !< 
+
+    REAL(wp) ::  fill_value = -999.0_wp  !< value for the _FillValue attribute
 
     REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb:nzt+1) ::  local_pf   !< local
@@ -731,4 +762,8 @@
              ENDDO
           ELSE
+             IF ( .NOT. ALLOCATED( diss_av ) ) THEN
+                ALLOCATE( diss_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                diss_av = REAL( fill_value, KIND = wp )
+             ENDIF
              DO  i = nxl, nxr
                 DO  j = nys, nyn
@@ -750,4 +785,8 @@
              ENDDO
           ELSE
+             IF ( .NOT. ALLOCATED( kh_av ) ) THEN
+                ALLOCATE( kh_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                kh_av = REAL( fill_value, KIND = wp )
+             ENDIF
              DO  i = nxl, nxr
                 DO  j = nys, nyn
@@ -769,4 +808,8 @@
              ENDDO
           ELSE
+             IF ( .NOT. ALLOCATED( km_av ) ) THEN
+                ALLOCATE( km_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                km_av = REAL( fill_value, KIND = wp )
+             ENDIF
              DO  i = nxl, nxr
                 DO  j = nys, nyn
Index: /palm/trunk/SOURCE/user_3d_data_averaging.f90
===================================================================
--- /palm/trunk/SOURCE/user_3d_data_averaging.f90	(revision 3003)
+++ /palm/trunk/SOURCE/user_3d_data_averaging.f90	(revision 3004)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Further allocation checks implemented
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -112,11 +115,13 @@
 !--       Sample for user-defined output:
 !          CASE ( 'u2' )
-!             DO  i = nxlg, nxrg
-!                DO  j = nysg, nyng
-!                   DO  k = nzb, nzt+1
-!                      u2_av(k,j,i) = u2_av(k,j,i) + u2(k,j,i)
+!             IF ( ALLOCATED( u2_av ) ) THEN
+!                DO  i = nxlg, nxrg
+!                   DO  j = nysg, nyng
+!                      DO  k = nzb, nzt+1
+!                         u2_av(k,j,i) = u2_av(k,j,i) + u2(k,j,i)
+!                      ENDDO
 !                   ENDDO
 !                ENDDO
-!             ENDDO
+!             ENDIF
 
           CASE DEFAULT
@@ -135,11 +140,13 @@
 !--       Sample for user-defined output:
 !          CASE ( 'u2' )
-!             DO  i = nxlg, nxrg
-!                DO  j = nysg, nyng
-!                   DO  k = nzb, nzt+1
-!                      u2_av(k,j,i) = u2_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+!             IF ( ALLOCATED( u2_av ) ) THEN
+!                DO  i = nxlg, nxrg
+!                   DO  j = nysg, nyng
+!                      DO  k = nzb, nzt+1
+!                         u2_av(k,j,i) = u2_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+!                      ENDDO
 !                   ENDDO
 !                ENDDO
-!             ENDDO
+!             ENDIF
 
        END SELECT
Index: /palm/trunk/SOURCE/user_data_output_2d.f90
===================================================================
--- /palm/trunk/SOURCE/user_data_output_2d.f90	(revision 3003)
+++ /palm/trunk/SOURCE/user_data_output_2d.f90	(revision 3004)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Further allocation checks implemented (averaged data will be assigned to fill
+! values if no allocation happened so far)
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -94,4 +98,6 @@
     LOGICAL      ::  two_d !< flag parameter that indicates 2D variables (horizontal cross sections)
 
+    REAL(wp) ::  fill_value = -999.0_wp    !< value for the _FillValue attribute
+
     REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb:nzt+1) ::  local_pf !< 
 
@@ -116,4 +122,8 @@
 !             ENDDO
 !          ELSE
+!             IF ( .NOT. ALLOCATED( u2_av ) ) THEN
+!                ALLOCATE( u2_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+!                u2_av = REAL( fill_value, KIND = wp )
+!             ENDIF
 !             DO  i = nxl, nxr
 !                DO  j = nys, nyn
Index: /palm/trunk/SOURCE/user_data_output_3d.f90
===================================================================
--- /palm/trunk/SOURCE/user_data_output_3d.f90	(revision 3003)
+++ /palm/trunk/SOURCE/user_data_output_3d.f90	(revision 3004)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Further allocation checks implemented (averaged data will be assigned to fill
+! values if no allocation happened so far)
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -87,5 +91,7 @@
     LOGICAL      ::  found !< 
 
-   REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !< 
+    REAL(wp) ::  fill_value = -999.0_wp    !< value for the _FillValue attribute
+
+    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !< 
 
 
@@ -109,4 +115,8 @@
 !             ENDDO
 !          ELSE
+!             IF ( .NOT. ALLOCATED( u2_av ) ) THEN
+!                ALLOCATE( u2_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+!                u2_av = REAL( fill_value, KIND = wp )
+!             ENDIF
 !             DO  i = nxl, nxr
 !                DO  j = nys, nyn
Index: /palm/trunk/SOURCE/uv_exposure_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/uv_exposure_model_mod.f90	(revision 3003)
+++ /palm/trunk/SOURCE/uv_exposure_model_mod.f90	(revision 3004)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Further allocation checks implemented (averaged data will be assigned to fill
+! values if no allocation happened so far) 
+! 
+! 2932 2018-03-26 09:39:22Z maronga
 ! renamed uvexposure_par to biometeorology_parameters
 ! 
@@ -331,4 +335,6 @@
     LOGICAL      ::  two_d !< flag parameter that indicates 2D variables (horizontal cross sections)
 
+    REAL(wp) ::  fill_value = -999.0_wp    !< value for the _FillValue attribute
+
     REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb:nzt+1) ::  local_pf !< 
 
@@ -353,4 +359,8 @@
 
        CASE ( 'uvem_vitd3dose*_xy' )        ! 2d-array
+          IF ( .NOT. ALLOCATED( vitd3_exposure_av ) ) THEN
+             ALLOCATE( vitd3_exposure_av(nysg:nyng,nxlg:nxrg) )
+             vitd3_exposure_av = REAL( fill_value, KIND = wp )
+          ENDIF
           IF ( av == 1 )  THEN
              DO  i = nxl, nxr
@@ -502,9 +512,11 @@
 
           CASE ( 'uvem_vitd3dose*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   vitd3_exposure_av(j,i) = vitd3_exposure_av(j,i) + vitd3_exposure(j,i)
+             IF ( ALLOCATED( vitd3_exposure_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      vitd3_exposure_av(j,i) = vitd3_exposure_av(j,i) + vitd3_exposure(j,i)
+                   ENDDO
                 ENDDO
-             ENDDO
+             ENDIF
 
 
Index: /palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- /palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3003)
+++ /palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3004)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! precipitation_rate_av removed
+! 
+! 3003 2018-04-23 10:22:58Z Giersch
 ! z_i is also written out to use the last known inversion height from the 
 ! initial run as the first inversion height which is written into the
@@ -1078,9 +1081,4 @@
        ENDIF
 
-       IF ( ALLOCATED( precipitation_rate_av ) )  THEN
-          CALL wrd_write_string( 'precipitation_rate_av' ) 
-          WRITE ( 14 )  precipitation_rate_av
-       ENDIF
-
        CALL wrd_write_string( 'pt' ) 
        WRITE ( 14 )  pt
